Attribute VB_Name = "FT232_2"
'    Device Initialization Codes are refered Openschemes code
'    Copyright 2009 Openschemes All Rights Reserved
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'   10/13/2010          Modified by SK Heo          To control usb to serial interface
'   02/09/2011          Modified by SK Heo          For general 8-bits control

Public IsOpen As Boolean
Public lHandle As Long
Public GotDevice As Boolean

'Private Declare Sub Delay Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)
Public Sub InitFT232()
    'FT232Frm.Show vbModal
End Sub

Public Sub CloseFT232()
    Dim lResult As Long
    If IsOpen Then lResult = FT_Close(lHandle)
    'Check for an error
    If result <> 0 Then Call CheckResult(lResult, "FT_OpenEx")
End Sub


Public Sub UpdateBitSetting(TargetAtten As Integer)
    ' Choose Parallel or Serial interface
    
    'Added ability to select rising or falling edge in the database by adding a suffix to the
    'ParallelOrSerial field. Use "Serial - Rising" or "Serial - Falling" in the database
    'CBG 2 needs to slice up each clock cycle into 6 or 8 parts to allow enough timing leeway with
    'clock edge so that the software can work with either edge.
        
    If ParallelOrSerial = "Parallel" And (NumBits1 + NumBits2) < 9 Then
        Set_Parallel (TargetAtten)
    ElseIf Left(ParallelOrSerial, 6) = "Serial" Then
        Set_Serial (TargetAtten)
    Else
        MsgBox "Check Data Format Again."
    End If
    
End Sub



Public Sub Set_Serial(TGain As Integer)
'TGain is now the Index1 or Index2 which is a decimal value representing the actual bits to be written to the part.
'It is not the dB or pF value.

    Dim bMyByte As String
    Dim lNumBytes As Long
    Dim lBytesDone As Long
    Dim lResult As Long
    Dim sBuffer As String
    Dim Dat(31) As Integer
    Dim SD() As Integer
    Dim m As Integer
    Dim n As Integer
    Dim i As Integer
    Dim Numb_Bits As Integer
    
    'Added ability to tack in chip address, register address, and SW settings.
    'Assumes data order is CHIP_ADDR[],REG_ADDR[],SW1,SW0,DATA[]
    'Future version may make this completely variable.
    Numb_Bits = NumBits1 + NumBits2
    
    m = 0
    If Chip_Addr <> "N/A" Then
        n = Len(Chip_Addr)
        Numb_Bits = Numb_Bits + n
        For i = 1 To n
           Dat(m) = CInt(Mid(Chip_Addr, i, 1))   'Note that MID command starts counting string positions at one and not zero like an array
           m = m + 1
        Next
    End If
    
    If Reg_Addr <> "N/A" Then
        n = Len(Reg_Addr)
        Numb_Bits = Numb_Bits + n
        For i = 1 To n
            Dat(m) = CInt(Mid(Reg_Addr, i, 1))
            m = m + 1
        Next
    End If
    
    If SW1_Enable <> "N/A" Then
        Dat(m) = SW1
        m = m + 1
        Numb_Bits = Numb_Bits + 1
    End If
    
    If SW2_Enable <> "N/A" Then
        Dat(m) = SW2
        m = m + 1
        Numb_Bits = Numb_Bits + 1
    End If
    
    If SW3_Enable <> "N/A" Then
        Dat(m) = SW3
        m = m + 1
        Numb_Bits = Numb_Bits + 1
    End If
    
    If SW4_Enable <> "N/A" Then
        Dat(m) = SW4
        m = m + 1
        Numb_Bits = Numb_Bits + 1
    End If
    
    'Load data bits here
    'And yes, "Numb_Bits" is a lame attempt at being punny
    For i = (Numb_Bits - 1) To m Step -1
        Dat(i) = (TGain Mod 2)             ' Remainder
        TGain = Int(TGain / 2)              ' Quotient
    Next
    
    'Flip the bits if the part is "low active"
    If LowHighActive = "Low" Then       ' not operation for low active
        For i = 0 To (Numb_Bits - 1)
            If Dat(i) = 1 Then
                Dat(i) = 0
            Else
                Dat(i) = 1
            End If
        Next
    End If
    
    
    'This trap is for the crazy RFSA3613 special case.
    'Similar serial data structure to the RFSA3713, except it uses 6 bits of the 8 bit data word instead of 7.
    'It doesn't ignore the last two MSB's like the rest of the civilized world would....
    'It ignores the MSB and the LSB.
    'Number of bits has to be entered into the database as 6 to keep the step size correct
    'but here it gets bumped up by one and the D() array right-shifted one position.
    If RFPartName = "RFSA3613" Then
        Numb_Bits = Numb_Bits + 1
        For i = 6 To 1 Step -1
            Dat(i) = Dat(i - 1)
            'don't care what D(0) is after right-shifting the array.
        Next
    'And now we have the RFSA3513 which uses 5 bits and skips the first two
    ElseIf RFPartName = "RFSA3513" Then
        Numb_Bits = Numb_Bits + 2
        For i = 6 To 2 Step -1
            Dat(i) = Dat(i - 2)
            'don't care what D(1) or D(0) is after right-shifting the array.
        Next
    'now we get the RFSA3523 which skips the first bit and ignores the last two.
    'Dammit, Design... some consistency would be nice.  Might have to add a Database field called "bit skip"
    'to get rid of these bandaids.
    
    ElseIf RFPartName = "RFSA3523" Then
        Numb_Bits = Numb_Bits + 1
        For i = 5 To 1 Step -1
            Dat(i) = Dat(i - 1)
            'don't care what D(0) is after right-shifting the array. Also don't care about D(6) or D(7)
        Next
    End If
    
         
         
    If MSBorLSB = "LSB" Then
       For i = 0 To (Numb_Bits \ 2 - 1)
            m = Dat(i)
            Dat(i) = Dat(Numb_Bits - 1 - i)
            Dat(Numb_Bits - 1 - i) = m
       Next i
    End If
    
    
    'Number of bytes = 2 times the humber of bits (for a high and low clock cycle)
    'Add 6 bytes for 3 bytes of LE at the beginning and end.
    lNumBytes = Numb_Bits * 2 + 6
    'ReDim D(NumOfBit - 1)
    'ReDim SD(Numb_Bits * 2 + 5)
    ReDim SD(lNumBytes - 1)
    


Start:
    'Do we have a waiting interface?
    If IsOpen = False Then
        MsgBox ("configure the interface Again...")
        'FT232Frm.Show vbModal
        'GoTo Start
        Exit Sub
    End If
    
    'First read the present state of the pins
    'lResult = FT_GetBitMode(lHandle, bMyByte)
    
    'Clear the buffer
    
    sBuffer = ""
    
    '' Debug code
    'MsgBox D(7) & D(6) & D(5) & D(4) & D(3) & D(2) & D(1) & D(0)
    'For i = 0 To Numb_Bits - 1
    '
    '    Debug.Print D(i)
    'Next i
    'Debug.Print "============="
    
    ' convert to sending data
    For i = 0 To (Numb_Bits - 1)
        
        If ParallelOrSerial = "Serial - Rising" Then
            'Rising Edge Case
            SD(i * 2 + 3) = Dat(i) * DATA_Bit
            SD(i * 2 + 4) = CLK_Bit + (Dat(i) * DATA_Bit)
        Else
            'Falling Edge Case
            SD(i * 2 + 3) = CLK_Bit + Dat(i) * DATA_Bit
            SD(i * 2 + 4) = Dat(i) * DATA_Bit
        End If
        
    Next
    
    ' Insert LE signal
    ' Most SPI parts do not need a LEADING LE pulse, but the RFAC36xx is confirmed to need a
    ' Falling edge to initiate a transaction.
    
    SD(0) = 0
    If Left(RFPartName, 4) = "RFAC" Then
        SD(1) = LE_Bit
    Else
        SD(1) = 0
    End If
    SD(2) = 0
    
    SD(Numb_Bits * 2 + 3) = 0
    SD(Numb_Bits * 2 + 4) = LE_Bit
    SD(Numb_Bits * 2 + 5) = 0
    
    bMyByte = ""
    
    For i = 0 To (Numb_Bits * 2 + 5) Step 1
        bMyByte = bMyByte + Chr(SD(i))
    Next i
         
    sBuffer = bMyByte
    Delay 0.1
        
        
    'Now write the entire buffer to the device
    lResult = FT_Write(lHandle, sBuffer, lNumBytes, lBytesDone)
    
    'SetBitMode command is just an experiment to toggle the CBus pins
    'lResult = FT_SetBitMode(lHandle, 241, 32)
    
    Delay 0.1
    If lResult <> 0 Then
        MsgBox "Gain Setting Failed. Set F232 Again"
        ControlPannel.USBFail
        'USBfailed = True
        'UsbSet.Enabled = True
        'FT232Frm.Show vbModal
        'GoTo Start
        Exit Sub
    End If
    sBuffer = ""                    ' Clear buffer
      
End Sub
Public Sub Set_Parallel(TGain As Single)

    Dim bMyByte As String
    Dim lNumBytes As Long
    Dim lBytesDone As Long
    Dim lResult As Long
    Dim sBuffer As String
    Dim DP(0 To 7) As Integer
    Dim SD As Integer
    Dim Numb_Bits As Integer
    
    Numb_Bits = NumBits1 + NumBits2
      
    'TGain = TGain / BitStep
        
    lNumBytes = 1
    
    'RFSA2614 is a special case where they shifted the outputs over one bit and didn't use C0.25
    'quickest way I know to get around this in the meantime (yes, another bandaid)
    'is to tell the program there are 7 bits and multiply TGain x 2
    'If RFPartName = "RFSA2614" Then
    '    TGain = TGain * 2
    '    Numb_Bits = 7
    'End If
      
    'Changed RFSA2614 bandaid to a more flexible version that allows more than one LSB to be skipped.  Knowing Ed's group, this will happen eventually.  :)
    'Idea is "right shift" by one the value to send to the FTDI for each o/p pin LSB pin skipped (and have to bump up the Bumb_Bits variable as well)
    'Best current example is the RFSA2614 which is a 6 bit version of the RFSA2714. To maintain pin compatibility, the 2614 is hooked up
    'the same as the 2714, including its connections to the FTDI, but it "C0.25" pin is not used.
    'All parallel mode controls are still assumed to be mapped LSB to MSB (i.e., in the same order as the FTDI output bits)
    i = 0
        Do Until D(i) <> "N/A"
        TGain = TGain * 2
        Numb_Bits = Numb_Bits + 1
        i = i + 1
    Loop
    

    ' Bit Conversion
    'For i = (NumOfBit - 1) To 0 Step -1
    For i = 0 To (Numb_Bits - 1)
        DP(i) = (TGain Mod 2)                ' Remainder
        TGain = Int(TGain / 2)              ' Quotient
        
        If LowHighActive = "Low" Then                    ' not operation for low active
            If DP(i) = 1 Then
                DP(i) = 0
            Else: DP(i) = 1
            End If
        Else
        End If
    Next
   
    ' set to 0 for unused DE signal
    If Numb_Bits <> 8 Then
        For i = Numb_Bits To 7
            DP(i) = 0
        Next
    End If
   
   ' Special case for RFSA3715 LE (hold LE high)
    If RFPartName = "RFSA3715-P" Or RFPartName = "RFSA3714-P" Then DP(7) = 1
    
    
    'check data
    'MsgBox DP(7) & DP(6) & DP(5) & DP(4) & DP(3) & DP(2) & DP(1) & DP(0)
   
    
Start:
    'Do we have a waiting interface?
    If IsOpen = False Then
        MsgBox ("configure the interface Again...")
        'FT232Frm.Show vbModal
        'GoTo Start
        Exit Sub
    End If
    
    
    'Clear the buffer
    sBuffer = ""
    
    ' convert to sending data
    SD = DP(7) * 128 + DP(6) * 64 + DP(5) * 32 + DP(4) * 16 + DP(3) * 8 + DP(2) * 4 + DP(1) * 2 + DP(0)
        
    bMyByte = Chr(SD)
        
    'check data
    'MsgBox bMyByte
       
    sBuffer = bMyByte
    Delay 0.1
        
        
    'Now write the entire buffer to the device
    lResult = FT_Write(lHandle, sBuffer, lNumBytes, lBytesDone)
    Delay 0.1
    If lResult <> 0 Then
        MsgBox "Gain Setting Failed. Set F232 Again"
        ControlPannel.USBFail
        'USBfailed = True
        'UsbSet.Enabled = True
        'FT232Frm.Show vbModal
        'GoTo Start
        Exit Sub
    End If
    sBuffer = ""                    ' Clear buffer





End Sub

Public Sub ReSet_Bits()
    Dim bMyByte As String
    Dim lNumBytes As Long
    Dim lBytesDone As Long
    Dim lResult As Long
    Dim sBuffer As String
    
    
    lNumBytes = 1
    bMyByte = Chr(0)
    'bMyByte = Chr(255)
    sBuffer = bMyByte
    Delay 0.1
    
        
    'Now write the entire buffer to the device
    lResult = FT_Write(lHandle, sBuffer, lNumBytes, lBytesDone)
    Delay 0.1
    If lResult <> 0 Then
        MsgBox "Reset bits Failed. Set F232 Again"
        ControlPannel.USBFail
        'USBfailed = True
        'UsbSet.Enabled = True
        'FT232Frm.Show vbModal
        'GoTo Start
        Exit Sub
    End If
    sBuffer = ""                    ' Clear buffer

End Sub

Public Sub CheckResult(lResult As Long, CallStr As String)
    If lResult <> 0 Then MsgBox ("Bad result: " & CallStr & " returned 0x" & Hex(lResult))
        MsgBox ("Reconnect USB Deviece and Run Program Again.")
        'Unload ControlPannel
        'USBfailed = True
        'UsbSet.Enabled = True
End Sub
Private Function TimeDelay(Delay As Double)
  Dim PauseTime, Start
  PauseTime = Delay    ' Set duration.
  Start = Timer    ' Set start time.
  Do While Timer < Start + PauseTime
    DoEvents    ' Yield to other processes.
  Loop
  
  'Just insert "Timedelay XX"  Where XX = the amount of delay time you need.
  
End Function
Public Sub Delay(ByVal Time As Single)
Dim Start As Single
Dim X As Long

    Start = Timer
    Do While Start + Time > Timer
        X = DoEvents
        If Start > Timer Then
        'for midnight rollover
            Start = Timer
        End If
    Loop
End Sub

