VERSION 5.00
Begin VB.Form FT232Frm 
   Caption         =   "FT232Bits"
   ClientHeight    =   7845
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11295
   FillStyle       =   0  'Solid
   LinkTopic       =   "Form1"
   ScaleHeight     =   7845
   ScaleWidth      =   11295
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txt_Baud 
      Height          =   285
      Left            =   1080
      TabIndex        =   7
      Text            =   "20000"
      Top             =   1800
      Width           =   855
   End
   Begin VB.TextBox txt_BitStates 
      Height          =   375
      Left            =   2040
      TabIndex        =   6
      Text            =   "0x??"
      Top             =   2400
      Width           =   615
   End
   Begin VB.CommandButton cmd_GetBits 
      Caption         =   "Get Bit States"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   2400
      Width           =   1695
   End
   Begin VB.CommandButton cmd_FTSetup 
      Caption         =   "Do bitbang Setup"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   3240
      Width           =   3135
   End
   Begin VB.CommandButton cmd_CloseInterface 
      Caption         =   "Close Interface"
      Height          =   375
      Left            =   1920
      TabIndex        =   3
      Top             =   1080
      Width           =   1335
   End
   Begin VB.CommandButton cmd_OpenInterface 
      Caption         =   "Open Interface"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   1335
   End
   Begin VB.ComboBox cmb_Interfaces 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Text            =   "No Interfaces yet.."
      Top             =   600
      Width           =   3135
   End
   Begin VB.CommandButton cmd_Find 
      Caption         =   "Find All FTDI Interfaces"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
   Begin VB.Label Label4 
      Caption         =   "kHz"
      Height          =   375
      Left            =   2160
      TabIndex        =   9
      Top             =   1800
      Width           =   615
   End
   Begin VB.Label Label3 
      Caption         =   "Data Clock"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   1800
      Width           =   975
   End
   Begin VB.Shape sh_DevState 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   1440
      Shape           =   3  'Circle
      Top             =   1080
      Width           =   495
   End
End
Attribute VB_Name = "FT232Frm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=====================================================================================
'    Copyright 2009 Openschemes All Rights Reserved
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'=====================================================================================
'   10/13/2010          Modified by SK Heo          To control usb to serial interface
'   02/08



Private Sub CheckResult(lResult As Long, CallStr As String)
    If lResult <> 0 Then MsgBox ("Bad result: " & CallStr & " returned 0x" & Hex(lResult))
End Sub


Private Sub cmd_BuffToggle_Click()
End Sub

Private Sub cmd_CloseInterface_Click()
    Dim lResult As Long
    If IsOpen Then lResult = FT_Close(lHandle)
    'Check for an error
    If Result <> 0 Then Call CheckResult(lResult, "FT_OpenEx")
    'Change connection indicator to red
    sh_DevState.FillColor = &HFF

End Sub

Private Sub cmd_Find_Click()
    Dim GotDevice As Boolean
    Dim lNumDevs As Long
    Dim lResult As Long
    Dim sBuffer As String * 50
    Dim sMyDescription As String
    
    cmb_Interfaces.Clear
    
    GotDevice = False
     
    'Get number of FTDI's connected to the system
   lResult = FT_GetNumDevices(lNumDevs, 0, FT_LIST_BY_NUMBER_ONLY)
   
    'Check for a total bombout
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_GetNumDevices")
        Exit Sub
    End If
    
    'Check for nothing connected
    If lNumDevs = 0 Then
        MsgBox ("No FTDI Devices Detected." & vbCrLf & "Please connect one..")
        Exit Sub
    End If
    
    'Loop through all adapters and check their description strings
    For i = 0 To lNumDevs - 1
        'Get a device's description
        lResult = FT_ListDevices(i, sBuffer, (FT_OPEN_BY_DESCRIPTION Or FT_LIST_BY_INDEX))
        'If we got one, check it for our devices
        If (InStr(sBuffer, "FT232B") Or InStr(sBuffer, "FT232R") Or InStr(sBuffer, "UM232")) Then
            'Hooray, we got one!  First flag it
            GotDevice = True
            'Now get the description and stuff it into the Interfaces combo box
            sMyDescription = Left(sBuffer, InStr(sBuffer, Chr(0)) - 1)
            cmb_Interfaces.AddItem (Str(i) & " - " & sMyDescription)

        End If
    Next i
    
    'Check to see if we successfully found anything
    If GotDevice = True Then
        'If so, update the combo box so it displays the first interface
        cmb_Interfaces.ListIndex = 0
    Else
        'If not, go display debug message and die
        Call CheckResult(lResult, "FT_ListDevices")
        Exit Sub
    End If
        
        
    
End Sub

Private Sub cmd_FTSetup_Click()
    Dim lResult As Long
    Dim lNumBytes As Long
    Dim lBytesDone As Long
    Dim lBitclock As Long
    Dim sBuffer As String * 1024
    
    'Do we have a connection open?
    If IsOpen = False Then
        MsgBox ("Please open an interface first..")
        Exit Sub
    End If
    
    'Check to see if the port is OK
    lResult = FT_GetQueueStatus(lHandle, lNumBytes)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_GetQueueStatus - pre clear")
        Exit Sub
    End If
    
    Do While lNumBytes > 256
        'Clear the buffer
        lResult = FT_Read(lHandle, sBuffer, 256, lBytesDone)
        If lResult <> 0 Then
            Call CheckResult(lResult, "FT_Read - loop")
            Exit Sub
        End If
        'Check to see if the port is empty
        lResult = FT_GetQueueStatus(lHandle, lNumBytes)
        If lResult <> 0 Then
            Call CheckResult(lResult, "FT_GetQueueStatus - loop")
            Exit Sub
        End If
    Loop
    
    'Get any residual bytes less than 256
    'Clear the buffer
    If lNumBytes > 0 Then lResult = FT_Read(lHandle, sBuffer, lNumBytes, lBytesDone)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_Read-final")
        Exit Sub
    End If
    
    'Now, the port should be empty...
    lResult = FT_GetQueueStatus(lHandle, lNumBytes)
    If lResult <> 0 Or lNumBytes <> 0 Then
        Call CheckResult(lResult, "FT_GetQueueStatus - post clear")
        Exit Sub
    End If
    
    
    
    'Set latency timer
    lResult = FT_SetLatencyTimer(lHandle, 16)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_SetLatencyTimer")
        Exit Sub
    End If
    
    'Reset the controller
    lResult = FT_SetBitMode(lHandle, &H0, &H0)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_SetBitMode-Reset")
        Exit Sub
    End If
    
    'Set asynchronous bit bang mode
    lResult = FT_SetBitMode(lHandle, &HFF, &H4)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_SetBitMode-BB Mode")
        Exit Sub
    End If
    
    
    'Baud rate is bitclock * 1000 /16.  User enters desired clock speed in kHz
    'and we multiply by 1000 to convert to Hz, then divide by 16 because the
    'FT232 already multiplies by 16
    lBitclock = Val(txt_Baud.Text) * 1000 / 16
    'Set baud rate
    lResult = FT_SetBaudRate(lHandle, lBitclock)
    If lResult <> 0 Then
        Call CheckResult(lResult, "FT_SetBaudRate")
        Exit Sub
    End If
    
    sh_DevState.FillColor = &HFF
    FT232Frm.Hide
    
End Sub

Private Sub cmd_GetBits_Click()
    Dim bMyByte As Byte
    Dim numbytes As Long
    
    'First read the present state of the pins
    lResult = FT_GetBitMode(lHandle, bMyByte)
    txt_BitStates.Text = "0x" & Hex(bMyByte)

End Sub

'Private Sub cmd_hi_Click()
    'Dim bMyByte As Byte
    'Dim numbytes As Long
    'Dim sBuffer As String
    
    'First read the present state of the pins
    'lResult = FT_GetBitMode(lHandle, bMyByte)
    
    'bMyByte = bMyByte Or (2 ^ (Val(txt_bit.Text)))
    'sBuffer = Chr(bMyByte)
    'lResult = FT_Write(lHandle, sBuffer, 1, numbytes)
    
'End Sub

'Private Sub cmd_Lo_Click()
    'Dim bMyByte As Byte
    'Dim numbytes As Long
    
    'First read the present state of the pins
    'lResult = FT_GetBitMode(lHandle, bMyByte)
    
    'bMyByte = bMyByte And Not (2 ^ (Val(txt_bit.Text)))
    'sBuffer = Chr(bMyByte)
    'lResult = FT_Write(lHandle, sBuffer, 1, numbytes)
    
'End Sub

Private Sub cmd_OpenInterface_Click()
    Dim lNumDevs As Long
    Dim lResult As Long
    Dim sMyDescription As String
    
    
    'First check to see if we have any interfaces
    If cmb_Interfaces.ListCount = 0 Then
        MsgBox ("Find and choose interface first..")
        Exit Sub
    End If
    
    'Get the selected interface from the combo box
    sMyDescription = cmb_Interfaces.List(cmb_Interfaces.ListIndex)
    sMyDescription = Right(sMyDescription, Len(sMyDescription) - 5)
    
    'Attempt to open the interface
    lResult = FT_OpenEx(sMyDescription, FT_OPEN_BY_DESCRIPTION, lHandle)
    
    'Check for a total bombout
    If Result <> 0 Then
        Call CheckResult(lResult, "FT_OpenEx")
        Exit Sub
    Else
        IsOpen = True
        'Change connection indicator to green
        sh_DevState.FillColor = &HFF00&
    End If
    
    
    
    'lResult = FT_Close(lHandle)
    
    
End Sub

'Private Sub cmd_Toggle_Click()
    'Dim bMyByte As Byte
    'Dim numbytes As Long
    'Dim sBuffer As String
    
    'Do we have a waiting interface?
    'If IsOpen = False Then
        'MsgBox ("Open and configure the interface first...")
        'Exit Sub
    'End If
        
    'First read the present state of the pins
    'lResult = FT_GetBitMode(lHandle, bMyByte)
    
    'For i = 1 To Val(txt_toggle.Text)
        'Raise bit
        'bMyByte = bMyByte Or (2 ^ (Val(txt_bit.Text)))
        'sBuffer = Chr(bMyByte)
        'lResult = FT_Write(lHandle, sBuffer, 1, numbytes)
        'lower bit
        'bMyByte = bMyByte And Not (2 ^ (Val(txt_bit.Text)))
        'sBuffer = Chr(bMyByte)
        'lResult = FT_Write(lHandle, sBuffer, 1, numbytes)
    'Next i
    
'End Sub

Private Sub Form_Load()
    Call cmd_Find_Click
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim lResult As Long
    If IsOpen Then lResult = FT_Close(lHandle)
    'Check for an error
    If Result <> 0 Then Call CheckResult(lResult, "FT_OpenEx")
    'Change connection indicator to red
    sh_DevState.FillColor = &HFF
End Sub

