Attribute VB_Name = "ParallelPort"
' Parallel Port Interface
Const AddressLPT1 = &H378
Const Statusport1 = AddressLPT1 + 1
Const Controlport1 = AddressLPT1 + 2


' Declare Parallel Port : DllPort.dll should be added
Public Declare Function Inp Lib "DllPort.dll" Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Public Declare Sub Out Lib "DllPort.dll" Alias "Out32" (ByVal PortAddress As Integer, ByVal value As Integer)

Public Sub PPUpdateBitSetting(TargetAtten As Single)
    ' Choose Parallel or Serial interface
    If ParallelOrSerial = "Parallel" And NumOfBit < 9 Then
        PPSet_Parallel (TargetAtten)
        
    ElseIf Left(ParallelOrSerial, 6) = "Serial" Then
        PPSet_Serial (TargetAtten)
    Else
        MsgBox "Check Data Format Again."
    End If
    
End Sub

Public Sub PPSet_Serial(TGain As Single)
    Dim D() As Integer
    Dim DelayTime As Single
    
    DelayTime = 0
        
    ReDim D(NumOfBit - 1)
        
    TGain = TGain / BitStep
        
    'Conver to binary number
    For i = 0 To (NumOfBit - 1)
        D(i) = (TGain Mod 2)                ' Remainder
        TGain = Int(TGain / 2)              ' Quotient
        If LowHighActive = "Low" Then       ' not operation for low active
            If D(i) = 1 Then
                D(i) = 0
            Else: D(i) = 1
            End If
        End If
    Next
    
    'Send Bits to the port
    Call Out(AddressLPT1, 0)                ' Initial bits
    Delay DelayTime
    Call Out(AddressLPT1, LE_Bit)
    Delay DelayTime
    Call Out(AddressLPT1, 0)
    Delay DelayTime
    
    If MSBorLSB = "MSB" Then
        For i = 0 To (NumOfBit - 1)             ' Send Control Bits
            If D((NumOfBit - 1) - i) = 0 Then
                Call Out(AddressLPT1, 0)
                Delay DelayTime
                Call Out(AddressLPT1, CLK_Bit)
                Delay DelayTime
            Else
                Call Out(AddressLPT1, DATA_Bit)
                Delay DelayTime
                Call Out(AddressLPT1, (CLK_Bit + DATA_Bit))
                Delay DelayTime
            End If
        Next
    ElseIf MSBorLSB = "LSB" Then
        For i = 0 To (NumOfBit - 1)             ' Send Control Bits
            If D(i) = 0 Then
                Call Out(AddressLPT1, 0)
                Delay DelayTime
                Call Out(AddressLPT1, CLK_Bit)
                Delay DelayTime
            Else
                Call Out(AddressLPT1, DATA_Bit)
                Delay DelayTime
                Call Out(AddressLPT1, (CLK_Bit + DATA_Bit))
                Delay DelayTime
            End If
        Next
    
    Else
        MsgBox ("Chech The Data Format. I should be MSB or LSB")
    End If
          

    Call Out(AddressLPT1, 0)                ' Ending bits
    Delay DelayTime
    Call Out(AddressLPT1, LE_Bit)
    Delay DelayTime
    Call Out(AddressLPT1, 0)
    Delay DelayTime

    'MsgBox ("PP Serial is selected")

End Sub

Public Sub PPSet_Parallel(TGain As Single)
        
    TGain = Int(TGain / BitStep1)
        
    If LowHighActive = "Low" Then                    ' not operation for low active
        TGain = Int((2 ^ NumOfBits1 - 1) Xor TGain)
    End If
    
    Call Out(AddressLPT1, TGain)
    Delay 0.1
    'MsgBox ("PP parallel is selected")

End Sub

Public Sub PPReSet_Bits()
    'MsgBox ("PP reset is selected")
    Call Out(AddressLPT1, &H0)                        ' Set 0
    Delay 0.1
    
End Sub
