Attribute VB_Name = "modComboBox"
' Copied from 'http://www.vb6.us/tutorials/visual-basic-combo-box-tutorial'
' Modified by SK HEO                        02/09/2011

Option Explicit

Public gstrATCDBTableName           As String
Public gstrATCDBFieldName           As String
Public gblnGetAllData               As Boolean  ' true = get all entries, false = go by 1st letter
Public gblnDropDownOnFocus          As Boolean

' Data Base Load Data
Public SelectedPart As String
Public RFPartName As String
Public ParallelOrSerial As String
Public NumBits1 As Integer
Public NumBits2 As Integer
Public BitStep1 As Double
Public BitStep2 As Double
Public BitMax1 As Integer
Public BitMax2 As Integer
Public LowHighActive As String
Public MSBorLSB As String
Public SW1_Enable As String
Public SW2_Enable As String
Public SW3_Enable As String
Public SW4_Enable As String
Public D(0 To 7) As String
Public LE_Bit As Integer, CLK_Bit As Integer, DATA_Bit As Integer
Public Chip_Addr As String                      ' Added for RFCAP series parts with fixed addresses
Public Reg_Addr As String                       ' Added for RFCAP series parts with fixed register address
Public Min_Value1 As Double                      ' May need to add hooks later to make this variable depending on future parts
Public Max_Value1 As Double
Public Min_Value2 As Double                      ' May need to add hooks later to make this variable depending on future parts
Public Max_Value2 As Double
Public GUI_Values1(0 To 255) As Double           ' Array for attenuator or cap settings based on index. Eliminates needing to constantly calculate and track values
Public GUI_Values2(0 To 255) As Double           ' Array for 2nd attenuator or cap settings based on index. Eliminates needing to constantly calculate and track values
Public Index1 As Integer                        'Index1 and 2 are for tracking where in the array we are.
Public Index2 As Integer
Public SW1 As Integer
Public SW2 As Integer
Public SW3 As Integer
Public SW4 As Integer
Public AttenValBox1Label As String
Public AttenValBox2Label As String
Public AttenValBox1Units As String
Public AttenValBox2Units As String

'Public USBfailed As Boolean

' Setting Parameter
Public AttenValue As Single, MaxAtten As Single, MinAtten As Single

Private Const CB_FINDSTRING         As Long = &H14C
Private Const CB_SHOWDROPDOWN       As Long = &H14F
Private Const LB_FINDSTRING         As Long = &H18F
Private Const CB_ERR                As Long = (-1)
Private Const CB_GETITEMHEIGHT      As Long = &H154
Private Const CB_SETDROPPEDWIDTH    As Long = &H160

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private gblnATCIgnoreTextChange As Boolean
Private gblnATCTextDeleted      As Boolean
Private gintATCSelStart         As Integer
Private gintATCSelLen           As Integer

'---------------------------------------------------------------------------------
Public Sub AutoTypeComboGotFocus(pobjCombo As ComboBox)
'---------------------------------------------------------------------------------
       
    Dim objRstDropDownData  As ADODB.Recordset
       
    ' Select existing text on entry to the combo box
    pobjCombo.SelStart = 0
    pobjCombo.SelLength = Len(pobjCombo.Text)
    
    ' if currently populated, drop it down
    If pobjCombo.ListCount > 0 And gblnDropDownOnFocus Then
        SendMessage pobjCombo.hwnd, CB_SHOWDROPDOWN, 1, ByVal 0&
    End If
     
    ' Load data                                 // SK
    LoadCombo pobjCombo, ""

    
End Sub

'---------------------------------------------------------------------------------
Public Sub AutoTypeComboKeyDown(pobjCombo As ComboBox, KeyCode As Integer, Shift As Integer)
'---------------------------------------------------------------------------------

    ' If the full text is selected and the user presses a letter or number,
    ' the selected text should be replaced
    If pobjCombo.SelText = pobjCombo.Text And ((KeyCode >= vbKeyA And KeyCode <= vbKeyZ) Or (KeyCode >= vbKey0 And KeyCode <= vbKey9)) Then
        pobjCombo.Text = ""
        gblnATCTextDeleted = False
        pobjCombo.Refresh
        Exit Sub
    End If
    
    ' If a user presses the "Delete" key, then the selected text
    ' is removed.
    If KeyCode = vbKeyDelete And pobjCombo.SelText <> "" Then
        ' Make sure that the text is not automatically re-entered
        ' as soon as it is deleted
        gblnATCIgnoreTextChange = True
        gintATCSelStart = pobjCombo.SelStart + 1
        gintATCSelLen = pobjCombo.SelLength
        pobjCombo.SelText = ""
        KeyCode = 0
        gblnATCTextDeleted = True
    Else
        gblnATCTextDeleted = False
    End If
    
End Sub

'---------------------------------------------------------------------------------
Public Sub AutoTypeComboKeyPress(pobjForm As Form, pobjCombo As ComboBox, KeyAscii As Integer)
'---------------------------------------------------------------------------------
    
    ' If a user presses the "Backspace" key,  then the selected text
    ' is removed. Autosearch is not re-performed, as that would only
    ' put it straight back again.
    
    Dim objCtl  As Control

    If Len(pobjCombo.Text) = 0 Then
        gblnATCIgnoreTextChange = False
        LoadCombo pobjCombo, IIf(gblnGetAllData, "", Chr$(KeyAscii))
        If pobjCombo.ListCount > 0 Then
            SetDropDownHeight pobjForm, pobjCombo, IIf(pobjCombo.ListCount < 8, _
                                                       pobjCombo.ListCount, 8)
        End If
        pobjForm.Refresh
        On Error Resume Next
        For Each objCtl In pobjForm.Controls
            objCtl.Refresh
        Next
    End If
    
    If pobjCombo.ListCount > 0 Then
        SetDropDownWidth pobjCombo
        SendMessage pobjCombo.hwnd, CB_SHOWDROPDOWN, 1, ByVal 0&
    End If

    If KeyAscii = 8 Then
        gblnATCIgnoreTextChange = True
        If Len(pobjCombo.SelText) > 0 Then
            pobjCombo.SelText = ""
            KeyAscii = 0
        End If
    End If
    
    ''if user presses enter, select the listindex
    'If KeyAscii = 13 Then
    '    pobjCombo.ListIndex = SendMessage(pobjCombo.hwnd, _
    '                                      CB_FINDSTRING, _
    '                                      -1, _
    '                                      ByVal CStr(pobjCombo.Text))
    'End If
    
End Sub

'---------------------------------------------------------------------------------
Public Sub AutoTypeComboChange(pobjCombo As ComboBox)
'---------------------------------------------------------------------------------
    
    Dim i           As Integer
    Dim l           As Long
    Dim strNewText  As String
    
    ' Check to see if a search is required.
    If gblnATCTextDeleted Then Exit Sub

    If Not gblnATCIgnoreTextChange And pobjCombo.ListCount > 0 Then
        l = SendMessage(pobjCombo.hwnd, CB_FINDSTRING, -1, ByVal CStr(pobjCombo.Text))
        strNewText = pobjCombo.List(l)
        If Len(pobjCombo.Text) <> Len(strNewText) Then
            ' Partial match found
            ' Avoid recursively entering this event
            gblnATCIgnoreTextChange = True
            i = Len(pobjCombo.Text)
            ' Attach the full text from the list to what has already been entered.
            ' This technique preserves the case entered by the user.
            pobjCombo.Text = pobjCombo.Text & Mid$(strNewText, i + 1)
            ' Select the text that is auto-entered
            pobjCombo.SelStart = i
            pobjCombo.SelLength = Len(Mid$(strNewText, i + 1))
        End If
    Else
        ' The IgnoreTextChange Flag is only effective for one Change event.
        gblnATCIgnoreTextChange = False
    End If

End Sub

'---------------------------------------------------------------------------------
Public Sub AutoTypeComboLostFocus(pobjCombo As ComboBox)
'---------------------------------------------------------------------------------

    On Error Resume Next
    
    If gblnATCTextDeleted Then
        If Len(pobjCombo.Text) > 0 Then
            pobjCombo.Text = Left$(pobjCombo.Text, gintATCSelStart - 1) & _
                             Mid$(pobjCombo.Text, gintATCSelStart + gintATCSelLen)
            pobjCombo.AddItem pobjCombo.Text
        End If
    End If

End Sub

'---------------------------------------------------------------------------------
Public Sub LoadCombo(pobjCombo As ComboBox, pstrLetter As String)
'---------------------------------------------------------------------------------
    
    Dim objRstDropDownData  As ADODB.Recordset
    Dim strSQL              As String
    Dim strWhereClause      As String
    Dim strWhereOrAnd       As String
    
    If pstrLetter = "" Then
        strWhereClause = ""
        strWhereOrAnd = " WHERE "
    Else
        strWhereOrAnd = " AND "
        If UCase$(pstrLetter) >= "A" And UCase$(pstrLetter) <= "Z" Then
            strWhereClause = " WHERE " & gstrATCDBFieldName & " LIKE '" & pstrLetter & "%'"
        Else
            strWhereClause = " WHERE " & gstrATCDBFieldName & " LIKE '[!A-Z]%'"
        End If
    End If
    
    strSQL = ""
    strSQL = strSQL & "SELECT " & gstrATCDBFieldName
    strSQL = strSQL & "  FROM " & gstrATCDBTableName
    strSQL = strSQL & strWhereClause
    strSQL = strSQL & strWhereOrAnd & gstrATCDBFieldName & " IS NOT NULL"
    strSQL = strSQL & " AND TRIM(" & gstrATCDBFieldName & ") <> ''"
    strSQL = strSQL & " ORDER BY " & gstrATCDBFieldName
    
    gobjCmd.CommandText = strSQL
    
    Set objRstDropDownData = gobjCmd.Execute
           
    With pobjCombo
        .Clear
        Do Until objRstDropDownData.EOF
            .AddItem objRstDropDownData.Fields(gstrATCDBFieldName)
            objRstDropDownData.MoveNext
        Loop
    End With
    
    objRstDropDownData.Close
    
    Set objRstDropDownData = Nothing

End Sub

'---------------------------------------------------------------------------------
Public Sub SetDropDownHeight(pobjForm As Form, _
                             pobjCombo As ComboBox, _
                             plngNumItemsToDisplay As Long)
'---------------------------------------------------------------------------------

    Dim pt              As POINTAPI
    Dim rc              As RECT
    Dim lngSavedWidth   As Long
    Dim lngNewHeight    As Long
    Dim lngOldScaleMode As Long
    Dim lngItemHeight   As Long

    lngSavedWidth = pobjCombo.Width

    lngOldScaleMode = pobjForm.ScaleMode
    pobjForm.ScaleMode = vbPixels
    
    lngItemHeight = SendMessage(pobjCombo.hwnd, CB_GETITEMHEIGHT, 0, ByVal 0)
    
    lngNewHeight = lngItemHeight * (plngNumItemsToDisplay + 2)
    
    Call GetWindowRect(pobjCombo.hwnd, rc)
    pt.X = rc.Left
    pt.Y = rc.Top
    
    Call ScreenToClient(pobjForm.hwnd, pt)
    
    Call MoveWindow(pobjCombo.hwnd, pt.X, pt.Y, pobjCombo.Height, lngNewHeight, True)
    
    pobjForm.ScaleMode = lngOldScaleMode
    pobjCombo.Width = lngSavedWidth

End Sub

'-----------------------------------------------------------------------------
Public Sub SetDropDownWidth(mCombo As ComboBox)
'-----------------------------------------------------------------------------

    Dim RetVal As Long
    Dim PixelWidth As Long
    Dim MaxWidth As Long
    Dim LoopCounter As Long
    Dim lWidth As Long

    For LoopCounter = 0 To mCombo.ListCount - 1
        lWidth = mCombo.Parent.TextWidth(mCombo.List(LoopCounter))
        If lWidth > MaxWidth Then
            MaxWidth = lWidth
        End If
    Next LoopCounter

    MaxWidth = MaxWidth + (23 * Screen.TwipsPerPixelX)
    If MaxWidth > (mCombo.Width * 2) Then
        MaxWidth = (mCombo.Width * 2)
    ElseIf MaxWidth < mCombo.Width Then
        MaxWidth = mCombo.Width
    End If

    PixelWidth = (MaxWidth \ Screen.TwipsPerPixelX)
    RetVal = SendMessage(mCombo.hwnd, CB_SETDROPPEDWIDTH, PixelWidth, 0)
    
End Sub

